%define         pname spamassassin
%define         pversion 3.4.2
%define         bversion 22
%define         rpmrelease iworx
%define         pdir Mail
%define	        spamd_user spamd
%define         epoch 2

# Distro Statements
%define		oscode rhe%{?rhel}x

%if 0%{?rhel} <= 7
%define 	ostype RedHat Enterprise %{?rhel}.x
%endif


%if 0%{?rhel} >= 8
%define 	ostype Almalinux %{?rhel}.x
%endif

%define	release %{bversion}.%{oscode}.%{rpmrelease}

Autoreq: 0

%define	    _use_internal_dependency_generator      0
%define     _unpackaged_files_terminate_build       0
%define     _missing_doc_files_terminate_build      0

%define     perl_sitelib %(eval "`%{__perl} -V:installsitelib`"; echo "$installsitelib")
%define 	perl_vendorlib  %(eval "`perl -V:installvendorlib`"; echo $installvendorlib)
%define 	perl_vendorarch  %(eval "`perl -V:installvendorarch`"; echo $installvendorarch)

%define 	krb5backcompat %([ -a /usr/kerberos/include/krb5.h ] ; then echo 1 || echo 0)

%define 	debug_package %{nil}

BuildRequires: 	perl
BuildRequires:	perl-Digest-SHA
BuildRequires:	perl(Digest::SHA1)
BuildRequires:	perl(HTML::Parser)
BuildRequires:	openssl-devel
BuildRequires:	perl(NetAddr::IP)
BuildRequires:  perl(Net::DNS)
BuildRequires:  perl(Time::HiRes)
BuildRequires:  perl(Archive::Tar)
BuildRequires:  perl(IO::Zlib)
BuildRequires:  perl(Digest::SHA)
BuildRequires:  perl(Compress::Zlib)
BuildRequires:  perl(DBI)
BuildRequires:  perl(LWP::UserAgent)
BuildRequires:  perl(HTTP::Date)
BuildRequires:  perl(ExtUtils::MakeMaker)
Requires:   gcc
Requires:	chkconfig
Requires:	initscripts
Requires:	perl-Digest-SHA
Requires:	perl(NetAddr::IP)
Requires: 	perl(HTML::Parser)
Requires: 	perl(Net::DNS)
Requires:   perl(Digest::SHA)
Requires: 	perl(Statistics::Distributions)
Requires: 	perl(Parse::Syslog)
Requires: 	perl(Pod::Usage)
Requires: 	perl(Pod::Parser)
Requires: 	perl(MIME::Base64)
Requires: 	perl(DB_File)
Requires: 	perl(Mail::SPF::Query)
Requires:	perl(Archive::Tar)
Requires: 	perl-libwww-perl
Requires:	perl(Net::IP)
Requires:	perl(Sys::Syslog)
Requires:	gnupg
Requires:	perl-Mail-SpamAssassin = %{epoch}:%{version}-%{release}
Requires:	perl(DBD::mysql)
Requires:	perl(Time::HiRes)
%define		ccflags %{optflags} -fPIC
%define		ldflags %{optflags}

%define 	__find_provides /usr/lib/rpm/find-provides

############### RPM ################################

Summary:        a spam filter for which can be invoked by mail delivery agents
Name:           %{pname}
Version:        %{pversion}
Release:        %{release}
License:        Artistic

Epoch:		2

Group:          Applications/Mail
Source0:        http://spamassassin.apache.org/released/Mail-SpamAssassin-%{pversion}.tar.gz
URL:            http://spamassassin.apache.org

Patch0:		spamassassin-enable-AWL.patch

Distribution:	InterWorx-HAL
Vendor:         INTERWORX L.L.C
Packager:	Paul Oehler <poehler@interworx.com>

BuildRoot:      %{_tmppath}/%{name}-%{version}-root

Requires(post): perl-version >= 0.77

Source1:	spamassassin.init
Source99:	filter-requires-spamassassin.sh

Provides:	SpamAssassin = %{epoch}:%{version}-%{release}
Provides:	SpamAssassin-tools
Provides:	perl-Mail-SpamAssassin = %{epoch}:%{version}-%{release}

Obsoletes:	SpamAssassin
Obsoletes:	SpamAssassin-tools
Obsoletes:	perl-Mail-SpamAssassin

%define 	__find_requires %{SOURCE99}

%description
SpamAssassin provides you with a way to reduce, if not completely eliminate,
Unsolicited Bulk Email (or "spam") from your incoming email.  It can be
invoked by a MDA such as sendmail or postfix, or can be called from a procmail
script, .forward file, etc.  It uses a genetic-algorithm-evolved scoring system
to identify messages which look spammy, then adds headers to the message so
they can be filtered by the user's mail reading software.  This distribution
includes the spamd/spamc components which considerably speeds processing of
mail.

%prep

%setup -q -n %{pdir}-SpamAssassin-%{version}

%patch0 -p1

# Display compilation flags and OS with colors ;)

if [ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] ; then rm -f %{_tmppath}/%{name}-%{pversion}-show_flags ; fi
cat <<EOF >>%{_tmppath}/%{name}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 5

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{name}-%{pversion}-show_flags
%{_tmppath}/%{name}-%{pversion}-show_flags
if [ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] ; then rm -f %{_tmppath}/%{name}-%{pversion}-show_flags ; fi

%build

unset LANG
%{__perl} Makefile.PL \
	INSTALLMAN1DIR=%{_mandir}/man1 \
	PREFIX=%{_prefix} \
	SYSCONFDIR=%{_sysconfdir} \
	DESTDIR=%{buildroot} \
	ENABLE_SSL=yes < /dev/null
%{__make} CC="gcc %{ccflags}" \
	\%{?krb5backcompat:SSLCFLAGS=-DSPAMC_SSL\ -I/usr/kerberos/include}
%{__make} CC="gcc %{ccflags}" \
	spamd/libspamc.so

%install

%makeinstall \
	INSTALLMAN1DIR=%{_mandir}/man1 \
	INSTALLMAN3DIR=%{_mandir}/man3 \
	INSTALLSITEMAN1DIR=%{_mandir}/man1 \
	INSTALLSITEMAN3DIR=%{_mandir}/man3 \
	INSTALLVENDORMAN1DIR=%{_mandir}/man1 \
	INSTALLVENDORMAN3DIR=%{_mandir}/man3

install -d %{buildroot}/%{_initrddir}
install -d %{buildroot}/%{_includedir}
install -m 0644 spamd/libspamc.so %{buildroot}/%{_libdir}
install -m 0644 spamc/libspamc.h %{buildroot}/%{_includedir}/libspamc.h
install -m 0700 %{SOURCE1} %{buildroot}/%{_initrddir}/spamassassin

mkdir -p %{buildroot}/etc/mail/spamassassin

mkdir -p %{buildroot}/etc/mail/spamassassin/sa-update-keys

if [ -x /usr/lib/rpm/brp-compress ] ; then /usr/lib/rpm/brp-compress ; fi

%clean
if [ -n "%{buildroot}" -a "%{buildroot}" != / ] ; then rm -rf %{buildroot} ; fi
if [ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] ; then rm -rf $RPM_BUILD_DIR/%{name}-%{pversion} ; fi

%post
if [ $1 -eq 1 ] ; then
/sbin/chkconfig --add spamassassin
/sbin/chkconfig --level 345 spamassassin on
fi;

# older versions used /etc/sysconfig/spamd whereas it should have been
# spamassassin, so fix it here
if [ -f /etc/sysconfig/spamd ]; then
  %{__sed} -e 's/^OPTIONS=/SPAMDOPTIONS=/' /etc/sysconfig/spamd > /etc/sysconfig/spamassassin
  %{__mv} /etc/sysconfig/spamd /etc/sysconfig/spamassassin.rpmold
fi
# If spamd is running, let's be sure to change the lock file as well ...
if [ -f /var/lock/subsys/spamd ]; then
  %{__mv} /var/lock/subsys/spamd /var/lock/subsys/spamassassin
fi

wget http://spamassassin.apache.org/updates/GPG.KEY >/dev/null 2>&1 || :
/usr/bin/sa-update --import GPG.KEY >/dev/null 2>&1 || :
/bin/rm GPG.KEY 2> /dev/null || :
/usr/bin/sa-update || :

# for VPS shits, there is no network file on VPS OS template creation
if [ -f /etc/sysconfig/network ]; then
	/sbin/service spamassassin condrestart > /dev/null 2>&1 || :
fi

/usr/local/interworx/bin/php <<'EOF' &>/dev/null || :
<?php
require_once '/usr/local/interworx/include/iworx.conf.php';
if (IW::Env()->isNode()) {
    $dsn = Ini::get(Ini::VPOPMAIL_SPAM, 'dsn.orig');
} else {
    $dsn = Ini::get(Ini::VPOPMAIL_SPAM, 'dsn');
}

$DB = IWorxDbUtil::db_connect($dsn);
$sql = "ALTER TABLE `awl` ADD last_hit timestamp NOT NULL default CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP";
IWorxDbUtil::db_query($DB, $sql, false, false);
EOF

%pre
if [ -z "`/usr/bin/id -g %{spamd_user} 2>/dev/null`" ]; then
	%{_sbindir}/groupadd -r -f %{spamd_user} 2>&1 || :
fi

if [ -z "`/usr/bin/id -u %{spamd_user} 2>/dev/null`" ]; then
	%{_sbindir}/useradd -r -M -d /tmp  -s /sbin/nologin -c "SpamAssassin" -g %{spamd_user} %{spamd_user} 2>&1 || :
fi

%preun
if [ "$1" == "0" ]; then
   echo
   echo "WARNING: daemontools package removal request denied.  This package is required by Interworx."
   echo
   exit 1
fi

%postun
if [ $1 = 0 ]; then
	/sbin/service spamassassin stop >/dev/null 2>&1 || :
	/sbin/chkconfig --del spamassassin || :
fi

if [ $1 -eq 0 ]; then
	%{_sbindir}/userdel -r %{spamd_user} > /dev/null 2>&1 || :
else
	/sbin/service spamassassin condrestart > /dev/null 2>&1 || :
fi

##
## make sure that when we uprade from SpamAssassin to
## spamassassin that we don't lose the spamd usre
##

%triggerpostun -- SpamAssassin
if [ -z "`/usr/bin/id -g %{spamd_user} 2>/dev/null`" ]; then
	%{_sbindir}/groupadd -r -f %{spamd_user} 2>&1 || :
fi

if [ -z "`/usr/bin/id -u %{spamd_user} 2>/dev/null`" ]; then
	%{_sbindir}/useradd -r -M -d /tmp  -s /sbin/nologin -c "SpamAssassin" -g %{spamd_user} %{spamd_user} 2>&1 || :
	/sbin/service spamassassin restart > /dev/null 2>&1 || :
fi

%files
%defattr(-,root,root)
%doc README Changes sample-nonspam.txt sample-spam.txt INSTALL TRADEMARK USAGE
%attr(0755,root,root) %{_bindir}/*
%attr(0644,root,root) %{_includedir}/*
%attr(0644,root,root) %{_libdir}/*.so
%attr(0600,root,root) %dir %{_sysconfdir}/mail/spamassassin/sa-update-keys
%config(noreplace) %attr(0700,root,root) %{_initrddir}/spamassassin
%{_mandir}/man1/*
%doc sql
%if 0%{?rhel} >= 6
%{perl_vendorlib}/../*
%else
%{perl_sitelib}/*
%{_datadir}/spamassassin
%endif
%config(noreplace) %{_sysconfdir}/mail/spamassassin
%{_mandir}/man3/*

%changelog
* Thu Sep 16 2021 Joseph Purkis <jpurkis@interworx.com>
- Added Almalinux Build
* Mon Oct 08 2018 InterWorx Build System <support@interworx.com> - 3.4.2
- Automated update to version 3.4.2
* Thu Sep 22 2016 Matt Parmelee <mparmelee@interworx.com>
- Suppressed usage output from pgrep (re: previous change)
* Wed Jul 20 2016 Paul Oehler <poehler@interworx.com>
- Tweaked init script for el7 compatilibity
* Wed Mar 02 2016 Paul Oehler <poehler@interworx.com>
- Fixed init script return value for condrestart
* Fri May 01 2015 InterWorx Build System <support@interworx.com> - 3.4.1
- Automated update to version 3.4.1
* Tue Sep 30 2014 Matt Parmelee <mparmelee@interworx.com>
- Updated to 3.4.0
* Tue Aug 26 2014 Matt Parmelee <mparmelee@interworx.com>
- Updated for RHEL 7.x
* Thu Oct 11 2012 Matt Parmelee <mparmelee@interworx.com>
- Made run-level modification conditional
* Fri Oct 07 2010 Paul Oehler <poehler@interworx.com>
- Removed extraneous rpm output
* Sun Oct 03 2010 Paul Oehler <poehler@interworx.com>
- Added uninstall blocker preun script
* Thu Aug 12 2010 Paul Oehler <poehler@interworx.com>
- Added sa-update logic
* Thu May 06 2010 Paul Oehler <poehler@interworx.com>
- Updated for RHEL 6.x
* Tue Jun 17 2008 Paul Oehler <poehler@interworx.com>
- Updated for Fedora 9
* Tue May 13 2008 Paul Oehler <poehler@interworx.com>
- Added Fedora 8 support
- updated for version 3.2.4
* Tue Nov 7 2005  Chris Wells <clwells@nexcess.net>
- updated name to spamassassin from mixed case
- updated for 3.1.0
* Wed Oct 19 2005 Chris Wells <clwells@nexcess.net>
- update for VPS install
* Mon Jan 17 2005 Chris Wells <clwells@nexcess.net>
- Upgraded to 3.0.2 and made work with InterWorx-CP
* Sat Sep 11 2004 Chris Wells <clwells@nexcess.net>
- Repackaged for InterWorx-CP
* Tue Jun 29 2004 Daniel S. Reichenbach <dsr@best-off.org> 2.63-1.2.2
- Fix some typos in SPEC file
* Fri Jun 24 2004 Daniel S. Reichenbach <dsr@best-off.org> 2.63-1.2.1
- Initial Build.
